/*
 * Copyright 2014 SAS Institute Inc.
 * All Rights Reserved.
 *
 * NOTE: This is a generated file. Changes should be made in the underlying
 * source files (*.js, .library, etc) or they will be lost after the next generation
*/

jQuery.sap.declare("sas.hc.ui.core.library");
jQuery.sap.require("sap.ui.core.Core");

/**
 * @namespace
 * @name sas.hc.ui.core
 * @public
*/

// library dependencies
jQuery.sap.require("sap.ui.core.library");

// delegate further initialization of this library to the Core
sap.ui.getCore().initLibrary({
  name : "sas.hc.ui.core",
  dependencies : ["sap.ui.core"],
  types : [
  ],
  interfaces : [
  ],
  controls : [
    "sas.hc.ui.core.ComponentContainer",
    "sas.hc.ui.core.Control",
    "sas.hc.ui.core.CustomData",
    "sas.hc.ui.core.Element",
    "sas.hc.ui.core.GlobalSettings",
    "sas.hc.ui.core.HTML",
    "sas.hc.ui.core.Icon",
    "sas.hc.ui.core.Item",
    "sas.hc.ui.core.LayoutData",
    "sas.hc.ui.core.ListItem",
    "sas.hc.ui.core.LocalBusyIndicator",
    "sas.hc.ui.core.Message",
    "sas.hc.ui.core.ScrollBar",
    "sas.hc.ui.core.SeparatorItem",
    "sas.hc.ui.core.Title",
    "sas.hc.ui.core.TooltipBase",
    "sas.hc.ui.core.UIComponent",
    "sas.hc.ui.core.VariantLayoutData",
    "sas.hc.ui.core.applicationSwitcher/ApplicationSwitcherDiagnosticsPanel",
    "sas.hc.ui.core.mvc/HTMLView",
    "sas.hc.ui.core.mvc/JSAppView",
    "sas.hc.ui.core.mvc/JSONView",
    "sas.hc.ui.core.mvc/JSView",
    "sas.hc.ui.core.mvc/TemplateView",
    "sas.hc.ui.core.mvc/View",
    "sas.hc.ui.core.mvc/XMLView",
    "sas.hc.ui.core.search/OpenSearchProvider",
    "sas.hc.ui.core.search/SearchProvider",
    "sas.hc.ui.core.tmpl/DOMAttribute",
    "sas.hc.ui.core.tmpl/DOMElement",
    "sas.hc.ui.core.tmpl/Template",
    "sas.hc.ui.core.tmpl/TemplateControl"
  ],
  elements : [
  ],
  version : "203001.1.0-20150930114400_f0htmcm23p"});

//-----------------------------------------------------------------------------
//Begin of Library Initialization coding, copied from shared.js
//-----------------------------------------------------------------------------

(function() {

	var lazy = sap.ui.lazyRequire;

	function each(sPackage,aClasses,sShortcutPkg) {
		for(var i=0; i<aClasses.length; i++) {
			if ( sShortcutPkg ) {
				lazy(sShortcutPkg, aClasses[i].toLowerCase(), sPackage + aClasses[i]);
			} else {
			  lazy(sPackage + aClasses[i], "new extend getMetadata");
			}
		}
	}

	// lazy imports
	each("sas.hc.ui.core.mvc.", ["JSAppView"], "sas.hc.ui");

    // Initialize icons
	if(!sas.applicationSwitcher || !sas.applicationSwitcher._isMainApplication()){
		jQuery.sap.require("sas.hc.ui.core.IconRenderer_A11Y");
		jQuery.sap.require("sas.hc.ui.core.Icon_A11Y");
		jQuery.sap.require("sas.hc.ui.core.IconPool");
	    jQuery.sap.require("sas.hc.ui.core.theme.IconInitialization");
        sas.hc.ui.core.theme.IconInitialization.init();
	}
}());



/////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////SETTINGS CONSTANTS////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 * The name of the sas.eventBus Channel on which an event of the type change would be dispatched.
 * @public
 */
sas.hc.ui.core.SETTINGS_CHANNEL ="settingsChannel";

/**
 * This event will be fired against the settingsChannel of sas.eventBus after settings are persisted.
 * @public
 */
sas.hc.ui.core.SETTINGS_CHANGE = "settingsChange";


jQuery.sap.require("sap.ui.base.DataType");


/**
 * A color representation in hex format.
 *
 * @typedef {string} sas.hc.ui.core.Color
 *
 * @static
 * @public
 *
 */
sas.hc.ui.core.Color = sap.ui.base.DataType.createType("sas.hc.ui.core.Color", {
        isValid: function (value) {
            var hexPattern = new RegExp("^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$");
            return hexPattern.test(value);
        }
    },
    sap.ui.base.DataType.getType("string")
);


jQuery.sap.require('sas.hc.ui.core.GlobalSettings');

/////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////END SETTINGS CONSTANTS//////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////

/********************************************************
 ********** COMMENT MANAGER RELATED CHANGES ************
 ********************************************************/

/**
 * This is a method to get Comment service containg element-id in the url.
 * This method is added since comment rest service uri with element-id is not registered in the registry till 9.4M2.
 * Uri with element-id is registered in 9.4M3 with name as ContentElementCommentSummaryService so
 * when we move to 9.4M3 this method will be redundant and should be removed.
 *
 * @returns {*}
 */

if(jQuery.sap.getObject("sas.registry.wip")){

	sas.registry.wip.getContentElementCommentSummaryService = function() {

		var cs, sUrl;

		cs = jQuery.extend(true, {}, sas.registry.wip.getCommentService());
		cs.name = "ContentElementCommentSummaryService REST";
		cs.serviceInterface = "ContentElementCommentSummaryService REST";
		sUrl = cs.url;
		cs.url = sUrl.substring(0, sUrl.lastIndexOf("/")) + "/{element-id}" + sUrl.substring(sUrl.lastIndexOf("/"));

		return cs;
	}
}

/********************************************************
 ******* END OF COMMENT MANAGER RELATED CHANGES *********
 ********************************************************/
