/*
 * Copyright 2014 SAS Institute Inc.
 * All Rights Reserved.
 *
 * NOTE: This is a generated file. Changes should be made in the underlying
 * source files (*.js, .library, etc) or they will be lost after the next generation
*/

jQuery.sap.declare("sas.hc.ui.unified.library");
jQuery.sap.require("sap.ui.core.Core");

/**
 * @namespace
 * @name sas.hc.ui.unified
 * @public
*/

// library dependencies
jQuery.sap.require("sap.ui.unified.library");
jQuery.sap.require("sap.ui.core.library");

// delegate further initialization of this library to the Core
sap.ui.getCore().initLibrary({
  name : "sas.hc.ui.unified",
  dependencies : ["sap.ui.unified","sap.ui.core"],
  types : [
  ],
  interfaces : [
  ],
  controls : [
    "sas.hc.ui.unified.Calendar",
    "sas.hc.ui.unified.ContentSwitcher",
    "sas.hc.ui.unified.Currency",
    "sas.hc.ui.unified.DateRange",
    "sas.hc.ui.unified.FileUploader",
    "sas.hc.ui.unified.FileUploaderParameter",
    "sas.hc.ui.unified.Menu",
    "sas.hc.ui.unified.MenuItem",
    "sas.hc.ui.unified.MenuItemBase",
    "sas.hc.ui.unified.MenuTextFieldItem",
    "sas.hc.ui.unified.Shell",
    "sas.hc.ui.unified.ShellHeadItem",
    "sas.hc.ui.unified.ShellHeadUserItem",
    "sas.hc.ui.unified.ShellOverlay",
    "sas.hc.ui.unified.SplitContainer"
  ],
  elements : [
  ],
  version : "203001.1.0-20150930114400_f0htmcm23p"});

/*
calls to oEvent.stopPropagation(); and oEvent.preventDefault(); was being made un-conditionally, due to this onClick was not being called under the event chain.
Calendar handles month and year rendering under onClick. This fix is to enable keyboard access to see months and year views.
Related fixes are done in sas.hc.ui.unified.Calendar.js too.
 The fix of sas.hc.ui.unified.library-include.js and related are fixed by sap in version 1.22.10, hence any upgrade further to 1.22.10 of SAP.
 can override these changes, including that in sas.hc.ui.unified.library-include.js
 */
//SDK Copy Start - sinshb - HTMLCOMMONS-2250 - 1.22.8 - sap.ui.unified.Calendar - 668:701
jQuery.sap.require("sap.ui.unified.Calendar");
jQuery.sap.require("sas.hc.ui.unified.Calendar");
sap.ui.unified.Calendar.prototype.onsapselect = function(oEvent){

    // focused item must be selected
    var that = this;
    var iIndex = 0;
    var sasCal = new sas.hc.ui.unified.Calendar();

    switch (this._iMode) {
        case 0: // day picker
            if (jQuery.sap.containsOrEquals(this.getDomRef("days"), oEvent.target)) {
                sasCal._selectDay(that, new Date(this._getFocusedDate().getTime()));
                sasCal._fireSelect(that);
                //to prevent bubbling into input field if in DatePicker
                oEvent.stopPropagation();
                oEvent.preventDefault();
            }
            break;

        case 1: // month picker
            if (jQuery.sap.containsOrEquals(this.getDomRef("months"), oEvent.target)) {
                iIndex = this._oItemNavigation.getFocusedIndex();
                sasCal._selectMonth(that, iIndex);
            }
            break;

        case 2: // year picker
            if (jQuery.sap.containsOrEquals(this.getDomRef("years"), oEvent.target)) {
                iIndex = this._oItemNavigation.getFocusedIndex();
                sasCal._selectYear(that, iIndex);
            }
            break;
    }
};
//SDK Copy END
