/**
 * Created by rayoun on 10/23/14.
 */

(function() {

    jQuery.sap.require(
        "sas.hc.m.Button",
        "sas.hc.m.Dialog",
        "sas.hc.m.Label",
        "sas.hc.ui.layout.GridData",
        "sas.hc.ui.commons.RadioButtonGroup",
        "sas.hc.ui.core.Item",
        "sas.hc.ui.layout.form.Form",
        "sas.hc.ui.layout.form.ResponsiveGridLayout",
        "sas.hc.ui.layout.form.FormContainer",
        "sas.modelfactory.proxies.ScoreCodeProxy"
    );

    sap.ui.jsfragment("sas.modelfactory.dialog.DownloadScoreDialog", {

        modelGrp: null,
        fragData: null,

        createContent: function(controller) {
            var me = this;
            this.fragData = controller.scoreCodeFragData;


            this.modelGrp = new sas.hc.ui.commons.RadioButtonGroup({
            });
            var oItem = new sas.hc.ui.core.Item({
                text : sas.modelfactory.RB.getText("downloadScoreDialog.allModels.txt"),
                tooltip : sas.modelfactory.RB.getText("downloadScoreDialog.tooltip.allModels.txt"),
                key : "ALL_MODELS"
            });
            this.modelGrp.addItem(oItem);
            oItem = new sas.hc.ui.core.Item({
                text : sas.modelfactory.RB.getText("downloadScoreDialog.championModels.txt"),
                tooltip : sas.modelfactory.RB.getText("downloadScoreDialog.tooltip.championModels.txt"),
                key : "CHAMPION_MODELS"
            });
            this.modelGrp.addItem(oItem);

            var modelGrpLabel = new sas.hc.m.Label({
                text: sas.modelfactory.RB.getText("downloadScoreDialog.model.title.txt"),
                labelFor: this.modelGrp,
                required: false,
                layoutData: new sas.hc.ui.layout.GridData({span: "L2 M2 S12"})
            });
            this.modelGrp.setSelectedIndex(1);    // Default to champion


            var form =  new sas.hc.ui.layout.form.Form({
                layout: new sas.hc.ui.layout.form.ResponsiveGridLayout({
                    // change M breakpoint so the label is to the left of the
                    // field for the default dialog size.
                    breakpointM: 600
                }),
                formContainers: [
                    new sas.hc.ui.layout.form.FormContainer({
                        formElements: [
                            new sas.hc.ui.layout.form.FormElement({
                                label: modelGrpLabel,
                                fields: [this.modelGrp]
                            })
                        ]
                    })
                ]
            })

            var dialog = new sas.hc.m.Dialog({
                title: sas.modelfactory.RB.getText("downloadScoreDialog.title.txt"),
                contentWidth: "600px",
                contentHeight: "300px",
                content: [form],
                beginButton: new sas.hc.m.Button({
                    text: sas.modelfactory.RB.getText("downloadScoreDialog.button.download.txt"),
                    press: function() {
                        me.onDownloadScoreCode(controller, me);
                        dialog.close();
                    }
                }),
                endButton: new sas.hc.m.Button({
                    text: sas.modelfactory.RB.getText("downloadScoreDialog.button.cancel.txt"),
                    press: function() {
                        dialog.close();
                    }
                }),
                afterClose: function() {
                    dialog.destroy();
                }
            });

            return dialog;
        },

        onDownloadScoreCode: function(dialog) {
            var me = this;
            var data = me.fragData;

            if (data){
                // Build the report options
                var championModels = false;
                var selItem = me.modelGrp.getSelectedItem();
                if (selItem){
                    var key = selItem.getKey();
                    if (key === "CHAMPION_MODELS"){
                        championModels = true;
                    }
                }

                // Request download of the score code zip file
                scoreCodeProxy.downloadScoreCode(data.projectId, data.models, data.segments, championModels);
            }
        }
    });

})();