jQuery.sap.declare("sas.modelfactory.graph.JSGraphControl");
(function() {

    jQuery.sap.require("sas.modelfactory.graph.GraphControl");
    var GraphControl = sas.modelfactory.graph.GraphControl;

    GraphControl.extend("sas.modelfactory.graph.JSGraphControl", {

        init: function () {
            var graphLayout = new sap.m.FlexBox({width: "100%", height: "100%"});

            /* ATTENTION: Important
             * This is where the magic happens: we need a handle for our SVG to attach to. We can get this using .getIdForLabel()
             * Check this in the 'Elements' section of the Chrome Devtools:
             * By creating the Flexbox, we create elements specific for this control, and OPENUI5 takes care of
             * ID naming. With this ID, we can append an SVG tag inside the FlexBox
             */
            this.sParentId = graphLayout.getIdForLabel();

            this.setGraphView(graphLayout);
        }

    });
})();