/**
 * Created by rayoun on 9/15/14.
 */


jQuery.sap.require(
    "sas.modelfactory.Config",
    "sas.modelfactory.proxies.AbstractProxy",
    "sas.modelfactory.util.LogUtil"
);

(function(){

    jQuery.sap.declare('sas.modelfactory.proxies.RootProxy');

    rootProxy = {
        getRoot: function(onSuccess, onError, complete) {

            var url =  sas.modelfactory.Config.serverUrl + "/";
            logUtil.log(url);

            var options = {
                url:  url,
                sas: {crossDomain: true}, // Only *the very first* request to the mid-tier app from UI needs go through
                                            // the Cross Domain Proxy which will establish an authenticated session which can
                                            // then be used afterwards. This is a work-around as laid out in S1161879 for S1166960.
                                            // NOTE: Commenting out because it was determined that this change breaks web seal.
                type: 'GET',
                headers: {'Accept': 'application/json' },
                dataType: 'json'
            };

            abstractProxy.makeRequest(options, onSuccess, onError, complete)
        }
    };
})();