jQuery.sap.require(
    "sas.hc.m.Bar",
    "sas.hc.m.Button",
    "sas.hc.m.Dialog",
    "sas.hc.m.Label",
    "sas.hc.ui.layout.HorizontalLayout"
);

sas.hc.m.Dialog.extend("sas.modelfactory.report.ExpandedGraphDialog", {

    metadata: {
        events: {
            "closePress": {}
        }
    },

    renderer: "sap.m.DialogRenderer",

    init: function() {
        if(sas.hc.m.Dialog.prototype.init)
            sas.hc.m.Dialog.prototype.init.apply(this, arguments);

        this.setVerticalScrolling(false);
        this.setHorizontalScrolling(false);

        this.setShowHeader(false);

        this.titleLabel = new sas.hc.m.Text().addStyleClass("newProjectDialog-browseBtn");

        this.titleLayout = new sas.hc.ui.layout.HorizontalLayout({
            content: [this.titleLabel]
        });

        this.closeButton = new sas.hc.m.Button(this.getId() + "-closeButton", {
            icon: sas.icons.HC.NORMALVIEW,
//            text: sas.modelfactory.RB.getText("button.close.txt"),
            press: [this._onCloseButtonPress, this]
        }).addStyleClass("dialogCloseButton");

        var header = new sas.hc.m.Bar(this.getId() + "-header", {
            contentMiddle: [this.titleLayout],
            contentRight: [this.closeButton]
        }).addStyleClass("expandedGraph-header")
        this.setCustomHeader(header);

        this.attachAfterClose(this._onAfterClose, this);
    },

    setTitle: function(value) {
        this.setProperty("title", value);
        this.titleLabel.setText(value);

        // (S1153591) Set the toolTip on the title.  If label is too long for the title bar gets clipped.
        this.titleLabel.setTooltip(value)
    },

    _onAfterClose: function(evt) {
        this.destroy();
    },

    _onCloseButtonPress: function(evt) {
        this.close();
    }
});