jQuery.sap.declare("sas.modelfactory.report.RefreshableBarChartReport");
(function() {

    jQuery.sap.require("sas.modelfactory.graph.GraphControlRenderer");
    jQuery.sap.require("sas.modelfactory.report.BarChartReport");
    jQuery.sap.require("sas.modelfactory.report.ReportBarChart");

    jQuery.sap.require("sas.ltjs.gtl.models.data.DataSetDataProvider");

    var BarChartReport = sas.modelfactory.report.BarChartReport;
    var ReportBarChart = sas.modelfactory.report.ReportBarChart;

    var DataSetDataProvider = sas.ltjs.gtl.models.data.DataSetDataProvider;

    BarChartReport.extend("sas.modelfactory.report.RefreshableBarChartReport", {

        renderer: sas.modelfactory.graph.GraphControlRenderer,

        updateDataSet: function(jsonObject) {
            this.reportBarChart = new ReportBarChart(jsonObject);
            var dataSet = this.createDataSet();
            var dsdp = new DataSetDataProvider(dataSet);
            this.getGraph().getLayout().setDataProvider(dsdp);
        },

        destroy: function() {
            // Do nothing in the normal destroy
            var view = this;
        },

        destroyRefreshable: function() {
            // Custom method for refreshable type to be destroyed when view is ending
            BarChartReport.prototype.destroy.apply(this);
        }

    });
})();