jQuery.sap.declare("sas.modelfactory.report.RelativeImportanceGraph");
(function() {

    jQuery.sap.require("sas.modelfactory.graph.GraphControl");
    jQuery.sap.require("sas.modelfactory.graph.GraphControlRenderer");
    jQuery.sap.require("sas.ltjs.gtl.models.axis.AxisOptions");
//    jQuery.sap.require("sas.ltjs.gtl.models.core.styles.GraphSkinModel");
//    jQuery.sap.require("sas.ltjs.commons.styles.DataSkin");
    jQuery.sap.require("sas.ltjs.commons.models.data.dataset.DataSet");
    jQuery.sap.require("sas.ltjs.commons.models.data.dataset.DataType");
    jQuery.sap.require("sas.ltjs.commons.models.data.dataset.Column");
    jQuery.sap.require("sas.ltjs.gtl.models.core.Orientation");
    jQuery.sap.require("sas.ltjs.gtl.models.data.AnalysisRole");
    jQuery.sap.require("sas.ltjs.gtl.models.data.ClassificationRole");
    jQuery.sap.require("sas.ltjs.gtl.models.data.DataSetDataProvider");
    jQuery.sap.require("sas.ltjs.gtl.models.layoutOverlay.LayoutOverlay");
    jQuery.sap.require("sas.ltjs.gtl.models.layoutOverlay.barChart.BarChart");

    var GraphControl = sas.modelfactory.graph.GraphControl;

    var DataSet = sas.ltjs.commons.models.data.dataset.DataSet;
    var DataType = sas.ltjs.commons.models.data.dataset.DataType;
    var Column = sas.ltjs.commons.models.data.dataset.Column;

    var Orientation = sas.ltjs.gtl.models.core.Orientation;

//    var GraphSkinModel = sas.ltjs.gtl.models.core.styles.GraphSkinModel;
//    var DataSkin = sas.ltjs.commons.styles.DataSkin;

    var DataSetDataProvider = sas.ltjs.gtl.models.data.DataSetDataProvider;
    var AxisOptions = sas.ltjs.gtl.models.axis.AxisOptions;
    var LayoutOverlay = sas.ltjs.gtl.models.layoutOverlay.LayoutOverlay;
    var BarChart = sas.ltjs.gtl.models.layoutOverlay.barChart.BarChart;
    var ClassificationRole = sas.ltjs.gtl.models.data.ClassificationRole;
    var AnalysisRole = sas.ltjs.gtl.models.data.AnalysisRole;

    GraphControl.extend("sas.modelfactory.report.RelativeImportanceGraph", {

        layout: null,
        modelId: null,

        renderer: sas.modelfactory.graph.GraphControlRenderer,

        constructor: function() {
//            this.modelId = modelId;

            GraphControl.call(this);
        },

        init: function () {
            GraphControl.prototype.init.apply(this);

            this.layout = new LayoutOverlay();

            var graph = this.getGraph();

            var barChart = new BarChart();

            // Define a graph skin for 3D effect
//            var skin = new GraphSkinModel();
//            NONE:0,
//            PRESSED:1,
//            SHEEN:2,
//            CRISP:3,
//            GLOSS:4,
//            MATTE:5,
//            FLAT:6
//            skin.setDataSkin(DataSkin.MATTE);
//            barChart.setGraphSkin(skin);

            barChart.setOrientation(Orientation.HORIZONTAL);

            // Create the BarChart component
            var classificationRole = new ClassificationRole("modelId");
            barChart.setCategory(classificationRole);
            var analysisRole = new AnalysisRole("percentValue");
            barChart.setResponse([analysisRole]);

            // Set the layout overlay
            this.layout.setOverlays([barChart]);

            // Set up the axis options
            var xAxisOptions = this.layout.getXAxisOptions();
            xAxisOptions.setLabel("Relatvie Importance");
            xAxisOptions.getLinearOptions().setViewMax(1);
            xAxisOptions.getLinearOptions().setViewMin(0);

            var yAxisOptions = this.layout.getYAxisOptions();
            yAxisOptions.setLabel("");

            graph.setLayout(this.layout);
        },

        setPercentValue: function(percentValue) {
            if (percentValue === null)
                percentValue = 0.0;

            var dataSet = this.createDataSet(percentValue);

            var dsdp = new DataSetDataProvider(dataSet);
            this.layout.setDataProvider(dsdp);
        },

        createDataSet: function(percentValue) {
            var dataSet = new DataSet(true, true);
            var categoryCol = new Column();
            var responseCol = new Column();
            var rowVarCol = null;

            categoryCol.setName("modelId");
            responseCol.setName("percentValue");

            categoryCol.setDataType(DataType.STRING);
            responseCol.setDataType(DataType.NUMBER);

            categoryCol.setStrings(["modelId"]);
            responseCol.setNumbers([percentValue]);

            dataSet.addColumn(categoryCol);
            dataSet.addColumn(responseCol);

            return dataSet;
        }

    });
})();