jQuery.sap.declare("sas.modelfactory.report.ReportFactory");

jQuery.sap.require("sas.modelfactory.report.BarChartReport");
jQuery.sap.require("sas.modelfactory.report.RefreshableBarChartReport");
jQuery.sap.require("sas.modelfactory.report.DecisionTreeReport");
jQuery.sap.require("sas.modelfactory.report.HistogramReport");
jQuery.sap.require("sas.modelfactory.report.NetworkDiagramReport");
jQuery.sap.require("sas.modelfactory.report.SeriesPlotReport");
jQuery.sap.require("sas.modelfactory.report.TableReport");
jQuery.sap.require("sas.modelfactory.report.TextViewerReport");

/**
 * Factory for creating reports by type
 */
sas.modelfactory.report.ReportFactory = {

    createReport: function(jsonObject) {
        var report = null;

        switch(jsonObject.type) {
            case "BarChart":
                var BarChartReport = sas.modelfactory.report.BarChartReport;
                report = new BarChartReport(jsonObject);
                break;
            case "RefreshableBarChart":
                var RefreshableBarChartReport = sas.modelfactory.report.RefreshableBarChartReport;
                report = new RefreshableBarChartReport(jsonObject);
                break;
            case "SeriesPlot":
                var SeriesPlotReport = sas.modelfactory.report.SeriesPlotReport;
                report = new SeriesPlotReport(jsonObject);
                break;
            case "Histogram":
                var HistogramReport = sas.modelfactory.report.HistogramReport;
                report = new HistogramReport(jsonObject);
                break;
            case "DecisionTree":
                var DecisionTreeReport = sas.modelfactory.report.DecisionTreeReport;
                report = new DecisionTreeReport(jsonObject);
                break;
            case "NetworkDiagram":
                var NetworkDiagramReport = sas.modelfactory.report.NetworkDiagramReport;
                report = new NetworkDiagramReport(jsonObject);
                break;
            case "Table":
                var TableReport = sas.modelfactory.report.TableReport;
                report = new TableReport(jsonObject);
                break;
            case "TextViewer":
                var TextViewerReport = sas.modelfactory.report.TextViewerReport;
                report = new TextViewerReport(jsonObject);
                break;
        }

        return report;
    }

};