jQuery.sap.declare("sas.modelfactory.report.ReportTileRenderer");

sas.modelfactory.report.ReportTileRenderer = {};

sas.modelfactory.report.ReportTileRenderer.render = function(rm, tile) {
    rm.write("<div");
    rm.writeControlData(tile);
    rm.writeStyles();
    rm.writeClasses();
    rm.write(">");

    var header = tile.getAggregation("_header");
    if (header) {
        rm.write("<div");
        rm.addClass("objectmgr_masonryTile_header");
        rm.writeClasses();
        rm.write(">");
        rm.renderControl(header);
        rm.write("</div>");
    }

    var image = tile.getAggregation("image");
    if(image) {
        image.addStyleClass("objectmgr_masonryTile_image");
        if(!tile.getFillWidth()) {
            image.addStyleClass("objectmgr_masonryTile_imageNoFill");
        }
        rm.renderControl(image);
    }

    var details = tile.getAggregation("details");
    if(details) {
        details.addStyleClass("objectmgr_masonryTile_details");
        rm.renderControl(details);
    }

    rm.write("</div>");
};
